﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GanttView;
using Telerik.Windows.Controls.Scheduling;
using System.ComponentModel;

namespace GanttImplicitStyle
{
	public class ViewModel : ViewModelBase
	{
		private ObservableCollection<IGanttTask> tasks;
		private DateRange visibleRange;

		public ViewModel()
		{
			this.tasks = new SoftwarePlanning();
			var start = this.tasks.Min(t => t.Start).Date;
			var end = this.tasks.Max(t => t.End).Date;
			this.visibleRange = new DateRange(start.AddDays(-2), end.AddDays(2));
		}

		public ObservableCollection<IGanttTask> GanttTasks
		{
			get
			{
				return this.tasks;
			}
			set
			{
				this.tasks = value;
				this.OnPropertyChanged(() => this.GanttTasks);
			}
		}

		public DateRange VisibleRange
		{
			get
			{
				return this.visibleRange;
			}
			set
			{
				this.visibleRange = value;
				this.OnPropertyChanged(() => this.VisibleRange);
			}
		}
	}
}
